import React from 'react';
import { CropperMethodOptions } from 'react-advanced-cropper';
import './Navigation.scss';
export interface PublicNavigationProps {
    className?: string;
    buttonClassName?: string;
    rotateComponentClassName?: string;
    barClassName?: string;
    highlightedBarClassName?: string;
    activeBarClassName?: string;
    zeroBarClassName?: string;
    valueBarClassName?: string;
}
interface NavigationProps extends PublicNavigationProps {
    value: number;
    onRotate?: (angle: number, options?: CropperMethodOptions) => void;
    onFlip?: (horizontal: boolean, vertical?: boolean, options?: CropperMethodOptions) => void;
    className?: string;
    disabled?: unknown;
}
export interface NavigationRef {
    refresh: () => void;
}
export declare const Navigation: React.ForwardRefExoticComponent<NavigationProps & React.RefAttributes<NavigationRef>>;
export {};
